# This configuration file is meant to be used by smart-stopos as input to the nlblueprint/simulations/unified_simulation_script.py script
# It sets up a homogeneous chain of three abstract nodes with parameters defined in abstract_sim_params.yaml

network: three_node_abstract

abstract_sim_params: &abstract_params
  INCLUDE: !include abstract_sim_params.yaml

node: &node
  type: abstract_node
  properties:
    end_node: False
    num_positions: 2
    port_names:
      - A  # classical communication A side
      - B  # classical communication B side
      - ENT_A  # entanglement generation A side
      - ENT_B  # entanglement generation B side
    noiseless: False
    ID: null
    num_parallel_links: null
    <<: *abstract_params

ent_connection_properties: &ent_connection_properties
  dark_count_probability: 0.000001
  distributor: double_click

components:

  start_node:
    <<: *node
    properties:
      end_node: True
      port_names:
        - B
        - ENT_B
      noiseless: False
      ID: null
      num_positions: 2
      num_parallel_links: null
      <<: *abstract_params

  ent_connection_1:
    type: mid_heralded_connection
    properties:
      length: 113.25
      <<: *ent_connection_properties

    connect_to:
      node1: start_node
      node2: repeater_1
      port_name_node1: ENT_B
      port_name_node2: ENT_A
      label: entanglement_connection

  cl_connection_1:
    type: classical_connection
    properties:
      length: 113.25
    connect_to:
      node1: start_node
      node2: repeater_1
      port_name_node1: B
      port_name_node2: A
      label: classical_connection

  repeater_1:
    <<: *node

  ent_connection_2:
    type: mid_heralded_connection
    properties:
      length: 113.25
      <<: *ent_connection_properties
    connect_to:
      node1: repeater_1
      node2: end_node
      port_name_node1: ENT_B
      port_name_node2: ENT_A
      label: entanglement_connection

  cl_connection_2:
    type: classical_connection
    properties:
      length: 113.25
    connect_to:
      node1: repeater_1
      node2: end_node
      port_name_node1: B
      port_name_node2: A
      label: classical_connection

  end_node:
    <<: *node
    properties:
      end_node: True
      port_names:
        - A
        - ENT_A
      noiseless: False
      ID: null
      num_positions: 2
      num_parallel_links: null
      <<: *abstract_params

